/*
    This header file is part of CadCam.

    This header file is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This header file is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with CadCam.  If not, see <https://www.gnu.org/licenses/>.

    AUTOR     : Grotius
    DATE      : 14.06.2020
    REVISION  : --
    TODO      : --
    USAGE     : --
    PROTOCOL  : --
    NOTES     : --
*/
#include <iostream>
#include <algorithm>
#include <structs.h>
#include <math.h>
#include <lib/lib_intersect.h>
#include <lib/lib_offset.h>

double offset=0;
double resolution=0;

POINT arc_center(double xs,double ys,double xe, double ye, double radius);
ANGLE arc_angle(double xs,double ys, double xe, double ye, double xc, double yc);
//void check_line_line(std::vector<OBJECT>::iterator it, std::vector<OBJECT>::iterator it1);

//void cam_offset(){

//    cam.clear();
//    std::vector<std::vector<OBJECT>>::iterator it;
//    std::vector<OBJECT>::iterator it1,it2,it3,it4;
//    std::cout<<"cam init";
//    for(it=cam.begin(); it<cam.end(); it++){
//        std::cout<<"cam: "<<it-cam.begin()<<std::endl;
//    }

//    std::vector<OBJECT> temp;
//    //copy first offset
//    for(int i=0; i<contours.size(); i++){
//        if(contours.at(i).area<0){ //we got a yellow contour, perfect for testing a pocket algoritme
//            std::cout<<"yellow contour found"<<std::endl;

//            for(int j=0; j<contours.at(i).sequence.size(); j++){
//                int object = contours.at(i).sequence.at(j);

//                if(cad.at(object).type=="line"){
//                    OBJECT obj = line_offset(object,offset);
//                    temp.push_back(obj);
//                }
//                if(cad.at(object).type=="arc"){
//                    OBJECT obj = arc_offset(object,offset);;
//                    temp.push_back(obj);
//                }
//                if(cad.at(object).type=="circle"){
//                    OBJECT obj = circle_offset(object,offset);
//                    temp.push_back(obj);
//                }
//                if(cad.at(object).type=="linestrip" || cad.at(object).type=="rectangular" || cad.at(object).type=="polygon"){
//                    std::vector<OBJECT> obj = linestrip_offset(object,offset);
//                    for(int k=0; k<obj.size(); k++){
//                        temp.push_back(obj.at(k));
//                    }
//                }
//                if(cad.at(object).type=="spline"){
//                    std::vector<OBJECT> obj = spline_offset_as_linestrip(object,resolution,offset);
//                    for(int k=0; k<obj.size(); k++){
//                        temp.push_back(obj.at(k));
//                    }
//                }
//                if(cad.at(object).type=="ellipse"){
//                    std::vector<OBJECT> obj = ellipse_offset_as_linestrip(object,resolution,offset);
//                    for(int k=0; k<obj.size(); k++){
//                        temp.push_back(obj.at(k));
//                    }
//                }
//                if(cad.at(object).type=="bezier"){
//                    std::vector<OBJECT> obj = bezier_offset_as_linestrip(object,resolution,offset);
//                    for(int k=0; k<obj.size(); k++){
//                        temp.push_back(obj.at(k));
//                    }
//                }
//            }
//            cam.push_back(temp);
//            temp.clear();
//        }
//    }

//    std::cout<<"camsize: "<<cam.size()<<std::endl;
//}

void cam_offset_it(){

    cam.clear();
    std::vector<CONTOUR>::iterator it;
    std::vector<int>::iterator it1;
    std::vector<OBJECT>::iterator it2,it3;

    std::vector<OBJECT> temp;
    //copy first offset
    for(it=contours.begin(); it<contours.end(); it++){
        if(it->area<0 ||it->depth>0){ //we got a yellow contour, perfect for testing a pocket algoritme
            std::cout<<"yellow contour found"<<std::endl;

            for(it1=it->sequence.begin(); it1<it->sequence.end(); it1++){
                int object = *it1;
                //std::cout<<"int object: "<<object<<std::endl;
                it2=cad.begin()+object;
                it3=it2+1;
                //std::cout<<"it2 :"<<it2-cad.begin()<<std::endl;

                if(it2->type=="line"){
                    OBJECT obj=line_offset_it(it2,offset);
                    obj.red=255; obj.green=0; obj.blue=255; obj.alpha=255;
                    temp.push_back(obj);
                    OBJECT con;
                    con.type="connect";
                    con.red=255; con.green=0; con.blue=255; con.alpha=255;
                    con.start.x=obj.end.x;
                    con.start.y=obj.end.y;
                    con.start.z=obj.end.z;
                    temp.push_back(con);
                }
                if(it2->type=="arc"){
                    bool checked=true;
                    double temp_offset=offset;
                    if(temp_offset<0){
                        if(abs(temp_offset)>it2->radius){
                            checked=false;
                        }
                    }
                    if(checked){ //inside offset
                        if(std::round(it2->red)==255 && std::round(it2->green)==255){ //yellow, inside offset
                            OBJECT obj=arc_offset_it(it2,offset);
                            obj.red=255; obj.green=0; obj.blue=255; obj.alpha=255;
                            temp.push_back(obj);
                            OBJECT con;
                            con.type="connect";
                            con.red=255; con.green=0; con.blue=255; con.alpha=255;
                            con.start.x=obj.end.x;
                            con.start.y=obj.end.y;
                            con.start.z=obj.end.z;
                            temp.push_back(con);
                        } else { //red, outside offset
                            OBJECT obj=arc_offset_it(it2,abs(offset));
                            obj.red=255; obj.green=0; obj.blue=255; obj.alpha=255;
                            temp.push_back(obj);
                            OBJECT con;
                            con.type="connect";
                            con.red=255; con.green=0; con.blue=255; con.alpha=255;
                            con.start.x=obj.end.x;
                            con.start.y=obj.end.y;
                            con.start.z=obj.end.z;
                            temp.push_back(con);
                        }

                    }
                }
                if(it2->type=="circle"){
                    bool checked=true;
                    double temp_offset=offset;
                    if(temp_offset<0){
                        if(abs(temp_offset)>it2->radius){ //dont add circles with negative radius
                            checked=false;
                        }
                    }
                    if(checked){
                        if(std::round(it2->red)==255 && std::round(it2->green)==255){ //yellow, inside offset
                            OBJECT obj;
                            obj=circle_offset_it(it2,offset);
                            obj.red=255; obj.green=0; obj.blue=255; obj.alpha=255;
                            temp.push_back(obj);
                        }

                    }

                    if(std::round(it2->red)==255 && std::round(it2->green)==0){
                        OBJECT obj;
                        obj=circle_offset_it(it2,abs(offset));
                        obj.red=255; obj.green=0; obj.blue=255; obj.alpha=255;
                        temp.push_back(obj);
                    }


                }
                if(it2->type=="linestrip" || it2->type=="rectangular" || it2->type=="polygon"){
                    OBJECT obj;
                    obj=linestrip_offset_it(it2,offset);
                    obj.red=255; obj.green=0; obj.blue=255; obj.alpha=255;
                    temp.push_back(obj);
                    OBJECT con;
                    con.type="connect";
                    con.red=255; con.green=0; con.blue=255; con.alpha=255;
                    con.start.x=obj.end.x;
                    con.start.y=obj.end.y;
                    con.start.z=obj.end.z;
                    temp.push_back(con);
                }
                if(it2->type=="spline"){
                    OBJECT obj;
                    obj=spline_offset_as_linestrip_it(it2,resolution,offset);
                    obj.red=255; obj.green=0; obj.blue=255; obj.alpha=255;
                    temp.push_back(obj);
                    OBJECT con;
                    con.type="connect";
                    con.red=255; con.green=0; con.blue=255; con.alpha=255;
                    con.start.x=obj.end.x;
                    con.start.y=obj.end.y;
                    con.start.z=obj.end.z;
                    temp.push_back(con);
                }
                if(it2->type=="ellipse"){
                    OBJECT obj;
                    obj=ellipse_offset_as_linestrip_it(it2,resolution,offset);
                    obj.red=255; obj.green=0; obj.blue=255; obj.alpha=255;
                    temp.push_back(obj);
                    OBJECT con;
                    con.type="connect";
                    con.red=255; con.green=0; con.blue=255; con.alpha=255;
                    con.start.x=obj.end.x;
                    con.start.y=obj.end.y;
                    con.start.z=obj.end.z;
                    temp.push_back(con);
                }
                if(it2->type=="bezier"){
                    OBJECT obj;
                    obj=bezier_offset_as_linestrip_it(it2,resolution,offset);
                    obj.red=255; obj.green=0; obj.blue=255; obj.alpha=255;
                    temp.push_back(obj);
                    OBJECT con;
                    con.type="connect";
                    con.red=255; con.green=0; con.blue=255; con.alpha=255;
                    con.start.x=obj.end.x;
                    con.start.y=obj.end.y;
                    con.start.z=obj.end.z;
                    temp.push_back(con);
                }
            }
            cam.push_back(temp);
            temp.clear();
        }


        std::cout<<"camsize: "<<cam.size()<<std::endl;
    }
}

void connect_it()
{
    std::vector<std::vector<OBJECT>>::iterator it;
    std::vector<OBJECT>::iterator it1,it2,it3,it4;
    for(it=cam.begin(); it<cam.end(); it++){
        for(it1=it->begin(); it1<it->end(); it1++){
            it2=it1+1;
            if(it1==it->begin()){ //begin, mention swapped intersect sequence!
                it3=it->begin();
                it4=it->end()-1;
                if(it4->type=="connect" ){
                    it4->type="arc";
                    it4->end.x=it3->start.x;
                    it4->end.y=it3->start.y;
                    it4->end.z=it3->start.z;

                    //morpf into arc if 0>M_PI<0.5 , 1.5>M_PI<2*M_PI
                    double temp_offset=offset;
                    if(temp_offset<0){
                        temp_offset*-1;
                    }
                    it4->radius=offset;

                    //arc center
                    double radsq=it4->radius*it4->radius;
                    double q=sqrt(((it4->end.x-it4->start.x)*(it4->end.x-it4->start.x))+((it4->end.y-it4->start.y)*(it4->end.y-it4->start.y)));
                    double x3=(it4->start.x+it4->end.x)/2;
                    double y3=(it4->start.y+it4->end.y)/2;

                    it4->center.x=x3-sqrt(radsq-((q/2)*(q/2)))*((it4->start.y-it4->end.y)/q);
                    it4->center.y=y3-sqrt(radsq-((q/2)*(q/2)))*((it4->end.x-it4->start.x)/q);

                    it4->deg_angle_start=180/M_PI*(atan2(it4->end.y-it4->center.y, it4->end.x-it4->center.x)+M_PI);
                    it4->deg_angle_end=180/M_PI*(atan2(it4->start.y-it4->center.y, it4->start.x-it4->center.x)+M_PI);
                }
            }
            if(it1<it->end()-1){ //between it1 (connect end),it2 (start next)
                if(it1->type=="connect"){
                    it1->type="arc";
                    it1->end.x=it2->start.x;
                    it1->end.y=it2->start.y;
                    it1->end.z=it2->start.z;

                    //morpf into arc if 0>M_PI<0.5 , 1.5>M_PI<2*M_PI
                    double temp_offset=offset;
                    if(temp_offset<0){
                        temp_offset*-1;
                    }
                    it1->radius=offset;

                    //arc center
                    double radsq=it1->radius*it1->radius;
                    double q=sqrt(((it1->end.x-it1->start.x)*(it1->end.x-it1->start.x))+((it1->end.y-it1->start.y)*(it1->end.y-it1->start.y)));
                    double x3=(it1->start.x+it1->end.x)/2;
                    double y3=(it1->start.y+it1->end.y)/2;
                    //it1->center.x=x3+sqrt(radsq-((q/2)*(q/2)))*((it1->start.y-it1->end.y)/q); //G3
                    //it1->center.y=y3+sqrt(radsq-((q/2)*(q/2)))*((it1->end.x-it1->start.x)/q);

                    it1->center.x=x3-sqrt(radsq-((q/2)*(q/2)))*((it1->start.y-it1->end.y)/q); //G2
                    it1->center.y=y3-sqrt(radsq-((q/2)*(q/2)))*((it1->end.x-it1->start.x)/q);

                    it1->deg_angle_start=180/M_PI*(atan2(it1->end.y-it1->center.y, it1->end.x-it1->center.x)+M_PI);    //start angle G2
                    it1->deg_angle_end=180/M_PI*(atan2(it1->start.y-it1->center.y, it1->start.x-it1->center.x)+M_PI);    //end angle G2

                }
            }
        }
    }
}

void intersect_it()
{
    std::vector<std::vector<OBJECT>>::iterator it;
    std::vector<OBJECT>::iterator it1,it2,it3,it4;
    for(it=cam.begin(); it<cam.end(); it++){
        for(it1=it->begin(); it1<it->end(); it1++){
            it2=it1+1;

            if(it1==it->begin()){ //begin, mention swapped intersect sequence!
                it3=it->begin();
                it4=it->end()-1;
                if(it3->type=="arc" && it4->type=="line"){
                    //la_intersect(it4,it3);
                }
                if(it3->type=="line" && it4->type=="arc"){
                    //al_intersect(it4,it3);
                }
                if(it3->type=="arc" && it4->type=="arc"){
                    //aa_intersect(it4,it3);
                }
                if(it3->type=="line" && it4->type=="line"){
                    //ll_intersect(it4,it3);
                }
                if(it3->type=="line" && it4->type=="linestrip"){
                    ////lsl_intersect(it4,it3);
                }
                if(it3->type=="linestrip" && it4->type=="line"){
                    ////lls_intersect(it4,it3);
                }
            }

            if(it1<it->end()-1){ //between
                if(it1->type=="arc" && it2->type=="line"){
                    //al_intersect(it1,it2);
                }
                if(it1->type=="line" && it2->type=="arc"){
                    //la_intersect(it1,it2);
                }
                if(it1->type=="arc" && it2->type=="arc"){
                    //aa_intersect(it1,it2);
                }
                if(it1->type=="line" && it2->type=="line"){
                    //ll_intersect(it1,it2);
                }
                if(it1->type=="linestrip" && it2->type=="line"){
                    //lsl_intersect(it1,it2);
                }
                if(it1->type=="line" && it2->type=="linestrip"){
                    //lls_intersect(it1,it2);
                }
            }
        }
    }
}

//void check_line_line(std::vector<OBJECT>::iterator it, std::vector<OBJECT>::iterator it1){

//    bool place=0;


//            POINT a={cad.at(first).start.x,cad.at(first).start.y,0};
//            POINT b={x,y,0};
//            POINT c={cad.at(next).end.x,cad.at(next).end.y,0};

//            double pi_angle_start = atan2(a.y-b.y, a.x-b.x);    //start angle G2
//            double pi_angle_end = atan2(c.y-b.y, c.x-b.x);    //end angle G2


//            if (pi_angle_end<pi_angle_start)   //this to avoid the start angle is bigger then the end angle value
//            {
//                pi_angle_end+=2*M_PI;
//            }

//            std::cout<<"a.x "<<a.x<<"a.y "<<a.y<<std::endl;
//            std::cout<<"b.x "<<b.x<<"b.y "<<b.y<<std::endl;
//            std::cout<<"c.x "<<c.x<<"c.y "<<c.y<<std::endl;
//            std::cout<<"deg_start_angle: "<<pi_angle_start<<std::endl;
//            std::cout<<"deg_end_angle: "<<pi_angle_end<<std::endl;
//            std::cout<<"netto_angle: "<<(2*M_PI)-(pi_angle_end-pi_angle_start)<<std::endl;
//            double netto_pi_angle=(2*M_PI)-(pi_angle_end-pi_angle_start);
//            if(netto_pi_angle>M_PI){
//                place=1;
//                std::cout<<"place arc"<<std::endl;
//            } else place=0;
//            std::cout<<""<<std::endl;
//        }
//        return place;
//}

POINT arc_center(double xs,double ys,double xe, double ye, double radius){
    POINT p;
    double radsq=radius*radius;
    double q=sqrt(((xe-xs)*(xe-xs))+((ye-ys)*(ye-ys)));
    double x3=(xs+xe)/2;
    double y3=(ys+ye)/2;
    //p.x=x3+sqrt(radsq-((q/2)*(q/2)))*((ys-ye)/q); //G3
    //p.y=y3+sqrt(radsq-((q/2)*(q/2)))*((xe-xs)/q);

    p.x=x3-sqrt(radsq-((q/2)*(q/2)))*((ys-ye)/q); //G2
    p.y=y3-sqrt(radsq-((q/2)*(q/2)))*((xe-xs)/q);
    return p;
}

ANGLE arc_angle(double xs,double ys, double xe, double ye, double xc, double yc){
    ANGLE data;
    double pi_angle_start=atan2(ye-yc, xe-xc);
    double pi_angle_end=atan2(ys-yc, xs-xc);

    if (pi_angle_end<pi_angle_start)   //this to avoid the start angle is bigger then the end angle value
    {
        pi_angle_end+=2*M_PI;
    }

    data.deg_angle_start=180/M_PI*pi_angle_start;
    data.deg_angle_end=180/M_PI*pi_angle_end;

    std::cout<<"arc center x: "<<xc<<std::endl;
    std::cout<<"arc center y: "<<yc<<std::endl;
    std::cout<<"arc deg_start_angle: "<<pi_angle_start<<std::endl;
    std::cout<<"arc deg_end_angle: "<<pi_angle_end<<std::endl;

    return data;
}




//}
//                    if(place==1){
//                        OBJECT arc;
//                        arc.type="arc";
//                        arc.red=255; arc.green=255; arc.blue=0; arc.alpha=255;
//                        arc.start.x=objects.at(first).end.x;
//                        arc.start.y=objects.at(first).end.y;
//                        arc.end.x=objects.at(next).start.x;
//                        arc.end.y=objects.at(next).start.y;
//                        arc.radius=std::abs(offset);
//                        POINT p=arc_center(arc.start.x,arc.start.y,arc.end.x,arc.end.y,arc.radius);
//                        arc.center.x=p.x;
//                        arc.center.y=p.y;
//                        ANGLE a=arc_angle(arc.start.x,arc.start.y,arc.end.x,arc.end.y,arc.center.x,arc.center.y);
//                        arc.deg_angle_start=a.deg_angle_start;
//                        arc.deg_angle_end=a.deg_angle_end;
//                        arc.pocket=true;
//                        objects.push_back(arc);
//                    }
//}
//                    if(objects.at(source).type=="arc" && objects.at(next).type=="arc"){
//                        arc_arc_intersection_i(source,next);
//                    }
//                    if(objects.at(source).type=="line" && objects.at(next).type=="arc"){
//                        line_arc_intersection_i(source,next);
//                    }
//                    if(objects.at(source).type=="arc" && objects.at(next).type=="line"){
//                        arc_line_intersection_i(source,next);
//                    }




//                    }
//                    if(place==1){
//                        OBJECT arc;
//                        arc.type="arc";
//                        arc.red=255; arc.green=255; arc.blue=0; arc.alpha=255;
//                        arc.start.x=objects.at(next).end.x;
//                        arc.start.y=objects.at(next).end.y;
//                        arc.end.x=objects.at(first).start.x;
//                        arc.end.y=objects.at(first).start.y;
//                        arc.radius=std::abs(offset);
//                        POINT p=arc_center(arc.start.x,arc.start.y,arc.end.x,arc.end.y,arc.radius);
//                        arc.center.x=p.x;
//                        arc.center.y=p.y;
//                        ANGLE a=arc_angle(arc.start.x,arc.start.y,arc.end.x,arc.end.y,arc.center.x,arc.center.y);
//                        arc.deg_angle_start=a.deg_angle_start;
//                        arc.deg_angle_end=a.deg_angle_end;
//                        arc.pocket=true;
//                        objects.push_back(arc);
//                    }
//                    }
//                    if(objects.at(source).type=="arc" && objects.at(next).type=="arc"){
//                        arc_arc_intersection_i(next,source);
//                    }
//                    if(objects.at(source).type=="line" && objects.at(next).type=="arc"){
//                        arc_line_intersection_i(next,source);
//                    }
//                    if(objects.at(source).type=="arc" && objects.at(next).type=="line"){
//                        line_arc_intersection_i(next,source); //mention this one is swapped



//*/intersect each pocket, closed loop
//for(int i=0; i<pockets.size(); i++){
//    for(int j=0; j<pockets.at(i).sequence.size(); j++){

//        //between
//        if(j<pockets.at(i).sequence.size()-1){
//            int first=pockets.at(i).sequence.at(j);  std::cout<<"source: "<<first<<std::endl;
//            int next=pockets.at(i).sequence.at(j+1);   std::cout<<"next: "<<next<<std::endl;
//            if(objects.at(first).type=="line" && objects.at(next).type=="line"){
//                line_line_intersection_i(first,next);

//            }
//        }
//    }

//}

//for(int i=0; i<pockets.size(); i++){


//    int next=pockets.at(i).sequence.front(); std::cout<<"close loop source: "<<next<<std::endl;
//    int first=pockets.at(i).sequence.back();    std::cout<<"close loop next: "<<first<<std::endl;
//    if(objects.at(first).type=="line" && objects.at(next).type=="line"){

//        line_line_intersection_i(first,next);

//    }
//}*/





//for(int i=0; i<cam.size(); i++){
//    for(int j=0; j<cam.at(i).size(); j++){

//        std::cout<<"camcontours: "<<i<<" camobjects: "<<j<<std::endl;
//        std::cout<<"x "<<cam[i][j].start.x<<std::endl;
//        std::cout<<"y "<<cam[i][j].start.y<<std::endl;

//        if(j<cam.at(i).size()-1){
//            ll_intersect(j,j+1);
//        }
//        if(j==cam.at(i).size()-1){
//            ll_intersect(j,0);
//        }

//    }
//}












